package com.tuigai.tuigai_tongcheng_api.mapper;



import com.tuigai.tuigai_tongcheng_api.model.RefoundPasenger;
import org.apache.ibatis.annotations.*;

import java.util.List;

public interface RefoundPasengerMapper {
    //新增退票人
    @Insert("INSERT INTO `refound_passenger_tb` " +
            "(`outId`,`orderId`,`segmentId`, `passengerId`, `certificateNo`, `certificateType`, `passengerName`, " +
            "`ticketNo`, `price`, `seatType`, `ticketType`, `returnMoney`, `returnSuccess`, `chexiangNo`, `zuoweiNo`, `paySequenceNo`, `isReturn`, `isCallBack`, `vip_errand_return_price`, `stations`) " +
            "VALUES (" +
            "#{outId},#{orderId},#{segmentId}, #{passengerId}, #{certificateNo}, #{certificateType}, #{passengerName}," +
            "#{ticketNo}, #{price}, #{seatType}, #{ticketType}, #{returnMoney}, #{returnSuccess}, #{chexiangNo}, #{zuoweiNo}, #{paySequenceNo}, #{isReturn}, #{isCallBack}, #{vip_errand_return_price}, #{stations}" +
            ")")
    int addTrainPassenger(RefoundPasenger refoundPasenger);

    @Select("select `id`,`outId`,`segmentId`,`orderId`, `passengerId`, `certificateNo`, `certificateType`, `passengerName`, " +
            "`ticketNo`, `price`, `seatType`, `ticketType`, `returnMoney`, `returnSuccess`, `chexiangNo`, `zuoweiNo`, `paySequenceNo`, `isReturn`," +
            " `isCallBack`, `refoundfee12306`, `vip_errand_return_price`, `stations`,`psgNo`,trainId,birthDate,validDateEnd,countryCode,validDateStart,tel,sex,offlineRefundType,etxParam,returnTime" +
            " from refound_passenger_tb where outId=#{outId}")
    @Results(id = "RefoundPasengerResult", value = {
            @Result(property = "id", column = "id"),
            @Result(property = "outId", column = "outId"),
            @Result(property = "orderId", column = "orderId"),
            @Result(property = "passengerId", column = "passengerId"),
            @Result(property = "certificateNo", column = "certificateNo"),
            @Result(property = "certificateType", column = "certificateType"),
            @Result(property = "passengerName", column = "passengerName"),
            @Result(property = "ticketNo", column = "ticketNo"),
            @Result(property = "price", column = "price"),
            @Result(property = "seatType", column = "seatType"),
            @Result(property = "ticketType", column = "ticketType"),
            @Result(property = "returnMoney", column = "returnMoney"),
            @Result(property = "returnSuccess", column = "returnSuccess"),
            @Result(property = "chexiangNo", column = "chexiangNo"),
            @Result(property = "zuoweiNo", column = "zuoweiNo"),
            @Result(property = "paySequenceNo", column = "paySequenceNo"),
            @Result(property = "isReturn", column = "isReturn"),
            @Result(property = "isCallBack", column = "isCallBack"),
            @Result(property = "refoundfee12306", column = "refoundfee12306"),
            @Result(property = "vip_errand_return_price", column = "vip_errand_return_price"),
            @Result(property = "segmentId", column = "segmentId"),
            @Result(property = "stations", column = "stations"),
            @Result(property = "psgNo", column = "psgNo"),
            @Result(property = "trainId", column = "trainId"),
            @Result(property = "birthDate", column = "birthDate"),
            @Result(property = "validDateEnd", column = "validDateEnd"),
            @Result(property = "countryCode", column = "countryCode"),
            @Result(property = "validDateStart", column = "validDateStart"),
            @Result(property = "tel", column = "tel"),
            @Result(property = "sex", column = "sex"),
            @Result(property = "offlineRefundType", column = "offlineRefundType"),
            @Result(property = "etxParam", column = "etxParam"),
            @Result(property = "returnTime", column = "returnTime"),
    })
    List<RefoundPasenger> getRefoundPasengerByOutId(@Param("outId") String outId);


    //更新乘客信息
    @Update("update refound_passenger_tb set returnMoney=#{returnMoney},returnSuccess=#{returnSuccess}, refoundfee12306=#{refoundfee12306}," +
            "paySequenceNo=#{paySequenceNo},isReturn=#{isReturn} " +
            " where id=#{id}")
    int updateRefoundPasenger(RefoundPasenger refoundPasenger);

    //更新乘客回填信息
    @Update("update refound_passenger_tb set isCallBack=#{isCallBack} where id=#{id}")
    int updateRefoundPasengerIsCallBack(RefoundPasenger refoundPasenger);


    @Insert({
            "<script>",
            "INSERT INTO `refound_passenger_tb`" +
                    "        (`outId`,`orderId`,`segmentId`, `passengerId`, `certificateNo`, `certificateType`, `passengerName`," +
                    "        `ticketNo`, `price`, `seatType`, `ticketType`, `returnMoney`, `returnSuccess`, `chexiangNo`, `zuoweiNo`," +
                    "        `paySequenceNo`, `isReturn`, `isCallBack`, `vip_errand_return_price`, `stations`," +
                    "       trainId,birthDate,validDateEnd,countryCode,validDateStart,tel,sex)" +
                    "        values" +
                    " <foreach collection='refoundPasengerList' item='pasenger' separator=','>" +
                    "            ( #{pasenger.outId},#{pasenger.orderId},#{pasenger.segmentId}, #{pasenger.passengerId}," +
                    "            #{pasenger.certificateNo}," +
                    "            #{pasenger.certificateType}, #{pasenger.passengerName}," +
                    "            #{pasenger.ticketNo}, #{pasenger.price}, #{pasenger.seatType}, #{pasenger.ticketType}," +
                    "            #{pasenger.returnMoney}, #{pasenger.returnSuccess}, #{pasenger.chexiangNo}," +
                    "            #{pasenger.zuoweiNo}, #{pasenger.paySequenceNo}, #{pasenger.isReturn}, #{pasenger.isCallBack}," +
                    "            #{pasenger.vip_errand_return_price}," +
                    "            #{pasenger.stations},#{pasenger.trainId},#{pasenger.birthDate},#{pasenger.validDateEnd}," +
                    "#{pasenger.countryCode},#{pasenger.validDateStart},#{pasenger.tel},#{pasenger.sex} )" +
                    "        </foreach>",
            "</script>"
    })
//foreach item：表示循环中的单个值   separator表示用,分割  例如： （1,2,3）格式
    int addList(@Param("refoundPasengerList") List<RefoundPasenger> refoundPasengerList);


    @Update(" update `refound_passenger_tb`" +
            "        set `outId`={outId}" +
            "        where `id` = #{id}")
    int updateOutId(RefoundPasenger refoundPasenger);

    @Delete(" delete" +
            "        from `refound_passenger_tb`" +
            "        where `id` = #{id}")
    int removeById(@Param("id") Integer id);

    @Update({
            "<script>",
            "     update `refound_passenger_tb`" +
                    "        set `isCallBack` = #{isCallback}," +
                    "            `isReturn` =#{isReturn}" +
                    "        where `outId` =#{outId}" +
                    "        and `certificateNo` in" +
                    "        <foreach collection='cardNums' item='cardNum' separator=',' close=')' open='('>" +
                    "            #{cardNum}" +
                    "        </foreach>",
            "</script>"
    })
//foreach item：表示循环中的单个值   separator表示用,分割  例如： （1,2,3）格式
    int updateCallBackByOutIdAndCardNumIn(@Param("outId") String outId, @Param("cardNums") List<String> cardNums, @Param("isCallback") int isCallback, @Param("isReturn") int isReturn);


    @Update({
            "<script>",
            "     update `refound_passenger_tb`" +
                    "        set `isCallBack` = #{isCallback}," +
                    "            `isReturn` =#{isReturn}" +
                    "        where `outId` =#{outId}" +
                    "and (`isCallback`=0 or isCallback is null) " +
                    "        and `passengerId` in" +
                    "        <foreach collection='passengerIdList' item='cardNum' separator=',' close=')' open='('>" +
                    "            #{cardNum}" +
                    "        </foreach>",
            "</script>"
    })
    void updateCallBackByOutIdAndPassengerIdInWithIsCallbackNotNull(@Param("outId") String outId, @Param("passengerIdList") List<String> passengerIdList, @Param("isCallback") int isCallback, @Param("isReturn") int isRetrun);


    @Select("select `id`,`outId`,`segmentId`,`orderId`, `passengerId`, `certificateNo`, `certificateType`, `passengerName`, " +
            "`ticketNo`, `price`, `seatType`, `ticketType`, `returnMoney`, `returnSuccess`, `chexiangNo`, `zuoweiNo`, `paySequenceNo`, " +
            "`isReturn`, `isCallBack`, `refoundfee12306`, `vip_errand_return_price`, `stations`,`psgNo`,trainId,birthDate,validDateEnd," +
            "countryCode,validDateStart,tel,sex,offlineRefundType,etxParam,returnTime" +
            " from refound_passenger_tb where orderId=#{orderId}")
    @ResultMap(value = "RefoundPasengerResult")
    List<RefoundPasenger> getRefoundPasengerByOrderId(@Param("orderId") String orderId);
}
