package com.tuigai.tuigai_tongcheng_api.mapper;



import com.tuigai.tuigai_tongcheng_api.model.RefoundSegment;
import org.apache.ibatis.annotations.*;

import java.util.List;

@Mapper
public interface RefoundSegmentMapper {

    //新增乘机人
    @Insert("INSERT INTO `refound_segment_tb`" +
            "(`outId`,`orderId`, `from_station`, `to_station`, `from_time`, `to_time`, `trainCode`, `segment_index`, `seats`, `segmentTotalPrice`," +
            "trainId,trainDate,fromStationCode,toStationCode,ticketNum)" +
            "VALUES (" +
            "#{outId},#{orderId}, #{from_station}, #{to_station}, #{from_time}, #{to_time}, #{trainCode}, #{segment_index}, #{seats}, #{segmentTotalPrice}," +
            "#{trainId},#{trainDate},#{fromStationCode},#{toStationCode},#{ticketNum}" +
            ")")
    int addRefoundSegment(RefoundSegment refoundSegment);

    @Select("select `id`,`outId`,`orderId`, `from_station`, `to_station`, `from_time`, `to_time`, `trainCode`, `segment_index`, `seats`," +
            " segmentTotalPrice,trainId,trainDate,fromStationCode,toStationCode,ticketNum" +
            " from `refound_segment_tb`  where outId=#{outId}")
    @Results(id = "RefoundSegmentResults", value = {
            @Result(property = "id", column = "id"),
            @Result(property = "outId", column = "outId"),
            @Result(property = "orderId", column = "orderId"),
            @Result(property = "from_station", column = "from_station"),
            @Result(property = "to_station", column = "to_station"),
            @Result(property = "from_time", column = "from_time"),
            @Result(property = "to_time", column = "to_time"),
            @Result(property = "trainCode", column = "trainCode"),
            @Result(property = "segment_index", column = "segment_index"),
            @Result(property = "seats", column = "seats"),
            @Result(property = "trainId", column = "trainId"),
            @Result(property = "segmentTotalPrice", column = "segmentTotalPrice"),
            @Result(property = "trainDate", column = "trainDate"),
            @Result(property = "fromStationCode", column = "fromStationCode"),
            @Result(property = "toStationCode", column = "toStationCode"),
            @Result(property = "ticketNum", column = "ticketNum"),
    })
    List<RefoundSegment> getRefoundSegmentByoutId(@Param("outId") String outId);

}
