package com.tuigai.tuigai_tongcheng_api.mapper;



import com.tuigai.tuigai_tongcheng_api.model.RefoundTrainOrder;
import com.tuigai.tuigai_tongcheng_api.utils.IdsUtils;
import com.tuigai.tuigai_tongcheng_api.utils.Utils;
import org.apache.ibatis.annotations.*;

import java.util.List;
import java.util.Map;

@Mapper
public interface RefoundTrainOrderMapper {
    @Insert("INSERT INTO `refound_trainOrder_tb` (" +
            "`outId`,`orderId`, `orderId12306`, `callbackUrl`, `partnerId`, `fromStationName`, " +
            "`toStationName`, `trainCode`, `startTime`, `paper`, `onlinePay`, `companyId`,`payAccount`, `createTime`, `reqTime`, " +
            "`returntype`, `returnState`, `returnMoney`, `code`, `optUser`, `orderSource`, `orderPrice`, `returnOrderType`, `autopaySequenceNoStatus`, `returnOrderSpecial`," +
            " `remark`,`isManyPersonReturn`,`refundDeadline`,`isHaveZichuTui`,`accountAuditFlag`,`urgentTicket`,`refoundRepeatCount`," +
            "`isHaveChange`,`bizOrderId`,`isReturnMoney`,refundModel" +
            ") VALUES " +
            "(#{outId},#{orderId}, #{orderId12306}, #{callbackUrl}, #{partnerId}, #{fromStationName}," +
            " #{toStationName},#{trainCode},#{startTime},#{paper},#{onlinePay},#{companyId},#{payAccount},#{createTime},#{reqTime}," +
            " #{returntype}, #{returnState}, #{returnMoney}, #{code}, #{optUser}, #{orderSource}, #{orderPrice}, #{returnOrderType}, #{autopaySequenceNoStatus}, #{returnOrderSpecial}," +
            " #{remark},#{isManyPersonReturn},#{refundDeadline},#{isHaveZichuTui},#{accountAuditFlag},#{urgentTicket},#{refoundRepeatCount}," +
            "#{isHaveChange},#{bizOrderId},#{isReturnMoney},#{refundModel}" +
            ")")
    int addRefoundTrainOrder(RefoundTrainOrder refoundTrainOrder);

    @Update("update `refound_trainOrder_tb` set returnMoney=#{returnMoney},code=#{code},returntype=#{returntype} ,optUser=#{optUser},returnState=#{returnState}," +
            "returnOrderType=#{returnOrderType},autopaySequenceNoStatus=#{autopaySequenceNoStatus},returnOrderSpecial=#{returnOrderSpecial},remark=#{remark}" +
            " where outId =#{outId}")
    int updateRefoundTrainOrder(RefoundTrainOrder refoundTrainOrder);

    @Update("update `refound_trainOrder_tb` set fromStationName=#{fromStationName},toStationName=#{toStationName},trainCode=#{trainCode} ,startTime=#{startTime}" +
            " where outId =#{outId}")
    int updateRefoundTrainOrderStations(RefoundTrainOrder refoundTrainOrder);

    @Update("update `refound_trainOrder_tb` set isHaveZichuTui=2  where outId =#{outId}")
    int updateRefoundTrainOrderIsHaveZichuTui(RefoundTrainOrder refoundTrainOrder);

    //更新回调平台状态
    @Update("update `refound_trainOrder_tb` set callBackStatus=#{callBackStatus} where outId =#{outId}")
    int updateRefoundTrainOrderCallBackStatus(@Param("outId") String outId, @Param("callBackStatus") int callBackStatus);

    // 更新回调失败状态  callBackFailed   0未失败，1失败
    @Update("update `refound_trainOrder_tb` set callBackFailed=#{callBackFailed},callBackStatus=#{callBackStatus} where outId =#{outId}")
    public int updateRefoundTrainOrderCallBackFailedAndStatus(@Param("outId") String outId, @Param("callBackFailed") int callBackFailed,@Param("callBackStatus") int callBackStatus);

    //更新订单的退票状态的流水匹配状态 退票时间
    @Update("update `refound_trainOrder_tb` set autopaySequenceNoStatus=#{autopaySequenceNoStatus},returnState=#{returnState} ,createTime =#{createTime},returnOrderSpecial=#{returnOrderSpecial},remark=#{remark} where outId =#{outId}")
    int updateRefoundTrainOrderStatusAndPayNoStatus(RefoundTrainOrder refoundTrainOrder);


    @Select("select `id`,`outId`, `orderId`, `orderId12306`, `callbackUrl`, `partnerId`, `fromStationName`, `toStationName`, `trainCode`, `startTime`, " +
            "`paper`, `onlinePay`, `companyId`,`payAccount`, `createTime`, `reqTime`, `returntype`, `returnState`, `returnMoney`, `code`, `optUser`, `orderSource`, `orderPrice`," +
            " `returnOrderType`, `autopaySequenceNoStatus`, `returnOrderSpecial`,`callBackStatus`,`remark`,`isManyPersonReturn`,`refundDeadline`," +
            "`refoundRepeatCount`,`bizOrderId`,`isReturnMoney`,refundRate" +
            " from refound_trainOrder_tb where outId=#{outId}")
    @Results(id = "RefoundTrainOrderResult", value = {
            @Result(property = "id", column = "id"),
            @Result(property = "outId", column = "outId"),
            @Result(property = "orderId", column = "orderId"),
            @Result(property = "orderId12306", column = "orderId12306"),
            @Result(property = "callbackUrl", column = "callbackUrl"),
            @Result(property = "partnerId", column = "partnerId"),
            @Result(property = "fromStationName", column = "fromStationName"),
            @Result(property = "toStationName", column = "toStationName"),
            @Result(property = "trainCode", column = "trainCode"),
            @Result(property = "startTime", column = "startTime"),
            @Result(property = "paper", column = "paper"),
            @Result(property = "onlinePay", column = "onlinePay"),
            @Result(property = "companyId", column = "companyId"),
            @Result(property = "payAccount", column = "payAccount"),
            @Result(property = "createTime", column = "createTime"),
            @Result(property = "reqTime", column = "reqTime"),
            @Result(property = "returntype", column = "returntype"),
            @Result(property = "returnState", column = "returnState"),
            @Result(property = "returnMoney", column = "returnMoney"),
            @Result(property = "code", column = "code"),
            @Result(property = "optUser", column = "optUser"),
            @Result(property = "orderSource", column = "orderSource"),
            @Result(property = "orderPrice", column = "orderPrice"),
            @Result(property = "returnOrderType", column = "returnOrderType"),
            @Result(property = "autopaySequenceNoStatus", column = "autopaySequenceNoStatus"),
            @Result(property = "returnOrderSpecial", column = "returnOrderSpecial"),
            @Result(property = "callBackStatus", column = "callBackStatus"),
            @Result(property = "remark", column = "remark"),
            @Result(property = "isManyPersonReturn", column = "isManyPersonReturn"),
            @Result(property = "refundDeadline", column = "refundDeadline"),
            @Result(property = "refoundRepeatCount", column = "refoundRepeatCount"),
            @Result(property = "bizOrderId", column = "bizOrderId"),
            @Result(property = "isReturnMoney", column = "isReturnMoney"),
            @Result(property = "refundRate", column = "refundRate")
    })
    RefoundTrainOrder getRefoundTrainOrderByorderId(@Param("outId") String outId);


    //美团用
    @SelectProvider(type = RefoundTrainOrderSqlProvider.class, method = "searchRefoundTrainOrder")
    @Results(id = "RefoundTrainOrderResultmeituan", value = {
            @Result(property = "id", column = "id"),
            @Result(property = "outId", column = "outId"),
            @Result(property = "orderId", column = "orderId"),
            @Result(property = "orderId12306", column = "orderId12306"),
            @Result(property = "callbackUrl", column = "callbackUrl"),
            @Result(property = "partnerId", column = "partnerId"),
            @Result(property = "fromStationName", column = "fromStationName"),
            @Result(property = "toStationName", column = "toStationName"),
            @Result(property = "trainCode", column = "trainCode"),
            @Result(property = "startTime", column = "startTime"),
            @Result(property = "paper", column = "paper"),
            @Result(property = "onlinePay", column = "onlinePay"),
            @Result(property = "companyId", column = "companyId"),
            @Result(property = "payAccount", column = "payAccount"),
            @Result(property = "createTime", column = "createTime"),
            @Result(property = "reqTime", column = "reqTime"),
            @Result(property = "returntype", column = "returntype"),
            @Result(property = "returnState", column = "returnState"),
            @Result(property = "returnMoney", column = "returnMoney"),
            @Result(property = "code", column = "code"),
            @Result(property = "optUser", column = "optUser"),
            @Result(property = "orderSource", column = "orderSource"),
            @Result(property = "orderPrice", column = "orderPrice"),
            @Result(property = "returnOrderType", column = "returnOrderType"),
            @Result(property = "autopaySequenceNoStatus", column = "autopaySequenceNoStatus"),
            @Result(property = "returnOrderSpecial", column = "returnOrderSpecial"),
            @Result(property = "callBackStatus", column = "callBackStatus"),
            @Result(property = "payOrderNO", column = "payOrderNO"),
            //美团
            @Result(property = "seatType", column = "seatType"),
            @Result(property = "ticketType", column = "ticketType"),
            @Result(property = "passengerName", column = "passengerName"),
            @Result(property = "certificateType", column = "certificateType"),
            @Result(property = "certificateNo", column = "certificateNo"),
            @Result(property = "price", column = "price"),
            @Result(property = "isManyPersonReturn", column = "isManyPersonReturn"),
            @Result(property = "passengerId", column = "passengerId"),
            @Result(property = "refoundRepeatCount", column = "refoundRepeatCount")
    })
    List<RefoundTrainOrder> searchRefoundTrainOrder(
            @Param("outId") String outId,
            @Param("orderId") String orderId,
            @Param("passengerName") String passengerName,
            @Param("minTrainDate") String minTrainDate,
            @Param("maxTrainDate") String maxTrainDate,
            @Param("fromStationName") String fromStationName,
            @Param("toStationName") String toStationName,
            @Param("minCreateTime") String minCreateTime,
            @Param("maxCreateTime") String maxCreateTime,
            @Param("trainCode") String trainCode,
            @Param("returnState") String returnState,
            @Param("companyId") String companyId,
            @Param("certificateNo") String certificateNo,
            @Param("paySequenceNo") String paySequenceNo,
            @Param("orderSource") String orderSource,
            @Param("returnOrderType") String returnOrderType,
            @Param("page") int page,
            @Param("size") int size
    );

    @SelectProvider(type = RefoundTrainOrderSqlProvider.class, method = "countSearchRefoundTrainOrder")
    @Result(property = "count", column = "count")
    int countSearchRefoundTrainOrder(
            @Param("outId") String outId,
            @Param("orderId") String orderId,
            @Param("passengerName") String passengerName,
            @Param("minTrainDate") String minTrainDate,
            @Param("maxTrainDate") String maxTrainDate,
            @Param("fromStationName") String fromStationName,
            @Param("toStationName") String toStationName,
            @Param("minCreateTime") String minCreateTime,
            @Param("maxCreateTime") String maxCreateTime,
            @Param("trainCode") String trainCode,
            @Param("returnState") String returnState,
            @Param("companyId") String companyId,
            @Param("certificateNo") String certificateNo,
            @Param("paySequenceNo") String paySequenceNo,
            @Param("orderSource") String orderSource,
            @Param("returnOrderType") String returnOrderType
    );




    @Select("select `id`,`outId`, `orderId`, `orderId12306`, `callbackUrl`, `partnerId`, `fromStationName`, `toStationName`, `trainCode`, `startTime`, " +
            "`paper`, `onlinePay`, `companyId`,`payAccount`, `createTime`, `reqTime`, `returntype`, `returnState`, `returnMoney`, `code`, `optUser`, `orderSource`, `orderPrice`," +
            " `returnOrderType`, `autopaySequenceNoStatus`, `returnOrderSpecial`,`callBackStatus`,`remark`,`isManyPersonReturn`,`refundDeadline`,`refoundRepeatCount`,`bizOrderId`,`isReturnMoney`" +
            " from refound_trainOrder_tb where `orderId`=#{orderId} and `returntype`=#{returnType}")
    @ResultMap("RefoundTrainOrderResult")
    RefoundTrainOrder getByOrderIdAndReturnType(@Param("orderId") String orderId, @Param("returnType") String returnType);
    @Select("select `id`,`outId`, `orderId`, `orderId12306`, `callbackUrl`, `partnerId`, `fromStationName`, `toStationName`, `trainCode`, `startTime`, " +
            "`paper`, `onlinePay`, `companyId`,`payAccount`, `createTime`, `reqTime`, `returntype`, `returnState`, `returnMoney`, `code`, `optUser`, `orderSource`, `orderPrice`," +
            " `returnOrderType`, `autopaySequenceNoStatus`, `returnOrderSpecial`,`callBackStatus`,`remark`,`isManyPersonReturn`,`refundDeadline`,`refoundRepeatCount`,`bizOrderId`,`isReturnMoney`" +
            " from refound_trainOrder_tb where `orderId`=#{orderId} and `returntype`=#{returnType}")
    @ResultMap("RefoundTrainOrderResult")
    List<RefoundTrainOrder> findByOrderIdAndReturnType(@Param("orderId") String orderId, @Param("returnType") String returnType);


    /**
     * 内部类 sql
     */
    class RefoundTrainOrderSqlProvider {

        public String searchRefoundTrainOrder(Map<String, Object> map) {
            String outId = (String) map.get("outId");
            String orderId = (String) map.get("orderId");
            String passengerName = (String) map.get("passengerName");
            String minTrainDate = (String) map.get("minTrainDate");
            String maxTrainDate = (String) map.get("maxTrainDate");
            String fromStationName = (String) map.get("fromStationName");
            String toStationName = (String) map.get("toStationName");
            String minCreateTime = (String) map.get("minCreateTime");
            String maxCreateTime = (String) map.get("maxCreateTime");
            String trainCode = (String) map.get("trainCode");
            String returnState = (String) map.get("returnState");
            String companyId = (String) map.get("companyId");
            String certificateNo = (String) map.get("certificateNo");
            String paySequenceNo = (String) map.get("paySequenceNo");
            String orderSource = (String) map.get("orderSource");
            String returnOrderType = (String) map.get("returnOrderType");
            int page = (Integer) map.get("page");
            int size = (Integer) map.get("size");
            StringBuilder sql = new StringBuilder();

            String sqlconstens = "select t.id as id,t.outId as outId,t.`orderId` as orderId,  `orderId12306`, `callbackUrl`, `partnerId`, `fromStationName`, `toStationName`, `trainCode`, `startTime`, " +
                    "`paper`, `onlinePay`, `companyId` as companyName, `companyId` as companyId,`payAccount`,  `createTime`,  `returntype`, `returnState`, t.`returnMoney` as returnMoney, `code`, `optUser`,`orderSource`,`orderPrice`," +
                    "`returnOrderType`,`autopaySequenceNoStatus`,`returnOrderSpecial`,`callBackStatus`,t.returnOrderType as returnOrderType,t.remark as remark,t.isManyPersonReturn as isManyPersonReturn,refoundRepeatCount," +
                    " p.seatType as seatType,p.ticketType as ticketType,p.passengerName as passengerName,p.certificateType as certificateType," +
                    " p.certificateNo as certificateNo,p.price as price,p.paySequenceNo as paySequenceNo,p.paySequenceNo as payOrderNO,p.chexiangNo as chexiangNo,p.zuoweiNo as zuoweiNo," +
                    " p.returnTime as returnTime,p.returnMoney as returnMoney,p.refoundfee12306 as refoundfee12306,p.passengerId as passengerId" +
                    " from refound_trainOrder_tb as t  ";
            String sqlParam = buildRefoundTrainOrderSqlWhere(outId, orderId, minTrainDate, maxTrainDate, minCreateTime, maxCreateTime, fromStationName, toStationName, trainCode, returnState,
                    companyId, orderSource, returnOrderType);
            String sqlParamPassenger = buildtrainPassengerSqlWhere(passengerName, certificateNo, paySequenceNo);
            //有乘机人查询
            sql.append(sqlconstens).append("left join refound_passenger_tb as p on t.outId = p.outId where 1=1 ").append(sqlParam).append(sqlParamPassenger);

            sql.append(" GROUP BY t.`outId`  order by createTime desc ");
            sql.append(" limit ").append(page).append(",").append(size);
            System.out.println("退票查询SQL：");
            System.out.println(sql);
            return sql.toString();
        }

        public String countSearchRefoundTrainOrder(Map<String, Object> map) {
            String outId = (String) map.get("outId");
            String orderId = (String) map.get("orderId");
            String passengerName = (String) map.get("passengerName");
            String minTrainDate = (String) map.get("minTrainDate");
            String maxTrainDate = (String) map.get("maxTrainDate");
            String fromStationName = (String) map.get("fromStationName");
            String toStationName = (String) map.get("toStationName");
            String minCreateTime = (String) map.get("minCreateTime");
            String maxCreateTime = (String) map.get("maxCreateTime");
            String trainCode = (String) map.get("trainCode");
            String returnState = (String) map.get("returnState");
            String companyId = (String) map.get("companyId");
            String certificateNo = (String) map.get("certificateNo");
            String paySequenceNo = (String) map.get("paySequenceNo");
            String orderSource = (String) map.get("orderSource");
            String returnOrderType = (String) map.get("returnOrderType");
            StringBuilder sql = new StringBuilder();
            String sqlconstens = "select COUNT(DISTINCT(t.outId)) as count from refound_trainOrder_tb as t  ";

            String sqlParam = buildRefoundTrainOrderSqlWhere(outId, orderId, minTrainDate, maxTrainDate, minCreateTime, maxCreateTime, fromStationName, toStationName, trainCode, returnState,
                    companyId, orderSource, returnOrderType);
            String sqlParamPassenger = buildtrainPassengerSqlWhere(passengerName, certificateNo, paySequenceNo);
            //有乘机人查询

            sql.append(sqlconstens).append("left join refound_passenger_tb as p on t.outId = p.outId where 1=1 ").append(sqlParam).append(sqlParamPassenger);


            System.out.println(sql);
            return sql.toString();
        }

        public String buildRefoundTrainOrderSqlWhere(String outId, String orderId, String minTrainDate, String maxTrainDate, String minCreateTime, String maxCreateTime,
                                                     String fromStationName, String toStationName, String trainCode, String returnState,
                                                     String companyId, String orderSource, String returnOrderType) {
            StringBuilder tsql = new StringBuilder();

            if (!Utils.isEmpty(outId)) {
                tsql.append(" and t.outId = '").append(outId).append("'");
            }
            if (!Utils.isEmpty(orderId)) {
                tsql.append(" and t.orderId = '").append(orderId).append("'");
            }
            if (!Utils.isEmpty(orderSource)) {
                tsql.append(" and t.orderSource = '").append(orderSource).append("'");
            }
            if (!Utils.isEmpty(minTrainDate) && !Utils.isEmpty(maxTrainDate)) {
                tsql.append(" and (t.startTime >='").append(minTrainDate).append("' and t.startTime <= '").append(maxTrainDate).append("')");
            }
            if (!Utils.isEmpty(minCreateTime) && !Utils.isEmpty(maxCreateTime)) {
                tsql.append(" and (t.createTime >='").append(minCreateTime).append("' and t.createTime <= '").append(maxCreateTime).append("')");
            }
            if (!Utils.isEmpty(fromStationName)) {
                tsql.append(" and t.fromStationName = '").append(fromStationName).append("'");
            }
            if (!Utils.isEmpty(toStationName)) {
                tsql.append(" and t.toStationName = '").append(toStationName).append("'");
            }
            if (!Utils.isEmpty(trainCode)) {
                tsql.append(" and t.trainCode = '").append(trainCode).append("'");
            }
            if (!Utils.isEmpty(returnState)) {
                tsql.append(" and t.returnState = '").append(returnState).append("'");
            }
            if (!Utils.isEmpty(companyId)) {
                tsql.append(" and t.companyId in (").append(IdsUtils.idsSplit(companyId)).append(")");
            }
            if (!Utils.isEmpty(returnOrderType)) {
                tsql.append(" and t.returnOrderType = '").append(returnOrderType).append("'");
            }

            return tsql.toString();
        }

        public String buildtrainPassengerSqlWhere(String passengerName, String certificateNo, String paySequenceNo) {
            StringBuilder pSql = new StringBuilder();
            if (!Utils.isEmpty(passengerName)) {
                pSql.append(" and p.passengerName='").append(passengerName).append("'");
            }
            if (!Utils.isEmpty(certificateNo)) {
                pSql.append(" and p.certificateNo='").append(certificateNo).append("'");
            }
            if (!Utils.isEmpty(paySequenceNo)) {
                pSql.append(" and p.paySequenceNo='").append(paySequenceNo).append("'");
            }

            return pSql.toString();
        }

    }
}
