package com.tuigai.tuigai_tongcheng_api.model;

import lombok.Data;

import java.io.Serializable;
import java.util.List;

@Data
public class RefoundTrainOrder implements Serializable {
    public Integer id;
    public String outId;//用此字段来做唯一id 商家传过来的sub_order_id
    public String orderId;//订单id
    public String bizOrderId;
    public String orderId12306;//12306订单号
    public String callbackUrl;//回调地址
    public String partnerId;//测试环境是meituan_test，线上是meituan，字段主要作为鉴权的参数使⽤
    public String fromStationName;//出发站
    public String toStationName;//到达站
    public String trainCode;//⻋次
    public String startTime;//出发时间，格式YYYY-MM-dd HH:mm:ss
    public Integer paper;//标记是否是现⾦票，true是现⾦票，false是电⼦票
    public Integer onlinePay;//是否是线上⽀付化退票订单
    public String companyId;//所属公司
    public String payAccount;//支付账号-后期导出报表用
    public String reqTime;//美团退票提交时间
    public String createTime;//创建时间
    public String returntype;//退票回调通知类型，线上 1 线下0
    public Integer returnState;//退票状态， 43--true退票成功，44--false退票失败  传给美团的时候，传true,false
    public Float returnMoney;//退票退款总⾦额
    public String code;//退票情况代码，参照【退票结果code说明】
    public List<RefoundPasenger> refoundPasengerList;
    public List<TrainReturnPayNo> returnPayNoList;
    public String optUser;//操作人
    public String orderSource;//订单来源
    public Float orderPrice;//
    public String payOrderNO;//出票支付流水号，需要和之前订单匹配
    public String passengerId;//退票子订单号
    public Integer refoundRepeatCount;//申请退票重复次数
    /**
     * 退票订单类型
     * 1、自出退票，2，代退订单，3、12306退票订单，4、高改低退差订单，
     */
    public String returnOrderType;
    /**
     * 自动匹配支付流水状态
     * 1、支付流水匹配成功，2、匹配异常人工处理
     */
    public String autopaySequenceNoStatus;

    /**
     * 退票订单其他异常标记
     * 0正常 1、退票特殊异常
     */
    public String returnOrderSpecial;
    /**
     * 0 回调失败 1回调成功
     */
    public Integer callBackStatus;//回调平台状态
    /**
     * 回调异常字段
     * 0 未异常   1 异常
     * 默认值 0
     */
    public int callBackFailed;
    public String remark;
    public Integer isManyPersonReturn;//是否多人退票 0 否，1 是

    public Integer userId;//Vo
    public String userName;//Vo

    public String seatType;//meituan
    public String ticketType;//meituan
    public String passengerName;//meituan
    public String certificateType;//meituan
    public String certificateNo;//meituan
    public String price;//meituan
    public String refundDeadline;//taobao


    public Integer isToday;//如果是当天就显示0，否则就是1
    public List<RefoundOrderOptLog> refoundOrderOptLogList;
    public List<RefoundSegment> refoundSegmentList;//新增的联程退票信息

    //2022-07-27 新增需求
    public Integer isHaveZichuTui;//是否含有自出退票 2 有 1 没有

    /**
     * 2022-08-18 新增需求
     */
    public String accountAuditFlag;//0非平台审计订单，1平台审计订单
    public String urgentTicket;//0非常经济票，1紧急票
    //2023-04-03新增需求
    public Integer isHaveChange;//是否有改签单 1是 0 否


    /**
     * 胜意
     */
    public Integer isReturnMoney;


    public String refundModel;//商旅 退票模式，线下退：0，⾃购退：1

    public String refundRate;//退票费率

    public RefoundTrainOrder() {
    }
}
