package com.tuigai.tuigai_tongcheng_api.redis;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.TimeUnit;

@Slf4j
@Service
public class StringRedisService {

    /**
     * 订单redis生命时长
     */
    public static final long orderLiveTime = 2 * 24 * 60 * 60;
    public static final long lockOrderLiveTime = 3 * 60;
    public static final long MUSICLiveTime = 60 * 60 * 24;
    public static final String TRAINNEWORDER = "火车票新订单:";

    public static final String PAIDANCHANGECOUNT = "PAIDANCHANGECOUNT:";
    public static final String PAIDANREFUNDCOUNT = "PAIDANREFUNDCOUNT:";
    public static final String TRAINORDERLOCKTIMES = "TRAINORDERLOCKTIMES:";
    public static final String REDIVIDEOUTTRAINORDERTIMES = "REDIVIDEOUTTRAINORDERTIMES:";//重新分配订单次数
    public static final String NEWORDERMISUCFLAG = "NEWORDERMISUCFLAG";//新订单音乐控制 后面加公司ID
    public static final String TUIPIAOMISUCFLAG = "TUIPIAOMISUCFLAG:";//新订单音乐控制 后面加公司ID
    public static final String TUIPIAOMISUCFLAGTWO = "TUIPIAOMISUCFLAGTWO:";//新订单音乐控制 后面加公司ID
    public static final String TUIPIAOMISUCFLAGHASREAD = "TUIPIAOMISUCFLAGHASREAD:";//退票新订单去重复

    public static final String GAIQIANMISUCFLAG = "GAIQIANMISUCFLAG:";//淘宝改签订单去重复
    public static final String GAIQIANMISUCFLAGTWO = "GAIQIANMISUCFLAGTWO:";//淘宝改签订单去重复
    public static final String GAIQIANMISUCFLAGHASREAD = "GAIQIANMISUCFLAGHASREAD:";//淘宝改签订单去重复
    public static final String TAOBAONEWTRAINORDER = "TAOBAOTRAINORDER:";//淘宝新票订单去重复
    public static final String TAOBAOREFOUNDTRAINORDER = "TAOBAOREFOUNDTRAINORDER:";//淘宝退票订单去重复
    public static final String TAOBAO_LOCKERROR_COUNT = "TAOBAO_LOCKERROR_COUNT:";
    public static final String BOHUIMUSICFLAG = "BOHUIMUSICFLAG:"; // 驳回单音乐控制

    public static final String ZICHUTUIPIAO_COUNT = "ZICHUTUIPIAO_COUNT:";//退票回调标记
    public static final String AUTO_TASK = "AUTO_TASK";//自动失败订单key
    public static final String AUTO_ON = "AUTO_ON";
    public static final String TASK_LOCK_1 = "TASK_LOCK_1";
    public static final String TASK_LOCK_2 = "TASK_LOCK_2";
    public static final String TASK_LOCK_3 = "TASK_LOCK_3";
    public static final String TASK_LOCK_4 = "TASK_LOCK_4";
    public static final String TASK_LOCK_5 = "TASK_LOCK_5";
    public static final String TASK_LOCK_6 = "TASK_LOCK_6";
    public static final String TASK_LOCK_7 = "TASK_LOCK_7";
    public static final String TASK_LOCK_8 = "TASK_LOCK_8";
    public static final String TASK_LOCK_9 = "TASK_LOCK_9";
    public static final String TASK_LOCK_10 = "TASK_LOCK_10";
    public static final String TASK_LOCK_11 = "TASK_LOCK_11";
    public static final String TASK_LOCK_12 = "TASK_LOCK_12";
    public static final String TASK_LOCK_13 = "TASK_LOCK_13";

    public static final String TASK_LOCK_14 = "TASK_LOCK_14";
    public static final String TASK_LOCK_15 = "TASK_LOCK_15";
    public static final String TASK_LOCK_16 = "TASK_LOCK_16";
    public static final String TASK_LOCK_17 = "TASK_LOCK_17";
    public static final String TASK_LOCK_18 = "TASK_LOCK_18";
    public static final String TASK_LOCK_19 = "TASK_LOCK_19";
    public static final String TASK_LOCK_20 = "TASK_LOCK_20";

    public static final String FILE_LOCK = "FILE_LOCK:";
    public static final String LOOK_IDCARD_LIMIT = "LOOK_IDCARD_LIMIT:";

    public static final String IMG_COUNT_LIMIT = "IMG_COUNT_LIMIT:";
    public static final String REFUND_ORDER = "REFUND_ORDER:";
    public static final String CHANGE_ORDER = "CHANGE_ORDER:";
    public static final String LOCK_PREEMPT_ORDER = "LOCK_PREEMPT_ORDER:";
    public static final String LOCK_PREEMPT_ORDER_INTERVAL = "LOCK_PREEMPT_ORDER_INTERVAL:";

    public static final String NOT_CREATE_ORDER_COUNT = "NOT_CREATE_ORDER_COUNT:";
    public static final String NOT_MATCH_ORDER_COUNT = "NOT_MATCH_ORDER_COUNT:";
    public static final String EXCEPTION_MARK_COUNT = "EXCEPTION_MARK_COUNT:";
    public static final String AUTO_ORDER_ID = "AUTO_ORDER_ID:";
    public static final String ASSIGN_AGAIN_REFUND = "ASSIGN_AGAIN_REFUND:";
    public static final String ASSIGN_AGAIN_CHANGE = "ASSIGN_AGAIN_CHANGE:";
    public static final String CHANGE_IS_HANDLE = "CHANGE_IS_HANDLE:";
    public static final String CHANGE_ESTIMATE_CHANGE_PRICE = "CHANGE_ESTIMATE_CHANGE_PRICE:";
    public static final String CHANGE_HANDLE_ORDER = "CHANGE_HANDLE_ORDER:";
    public static final String REFUND_HANDLE_ORDER = "REFUND_HANDLE_ORDER:";

    @Autowired
    private StringRedisTemplate stringRedisTemplate;

    public boolean tryLock(String key, String value, long liveTime) {
        // 尝试获取锁
        Boolean result = stringRedisTemplate.opsForValue().setIfAbsent(key, value, liveTime, TimeUnit.SECONDS);
        return result != null && result;
    }

    public void setString(String key, String value) {
        stringRedisTemplate.opsForValue().set(key, value);


    }

    public Long increment(String key) {
        return stringRedisTemplate.opsForValue().increment(key);


    }

    public Boolean expire(String key, long timeout, TimeUnit unit) {
        return stringRedisTemplate.expire(key, timeout, unit);


    }

    public void setUserLoginToken(String key, String value) {
        stringRedisTemplate.opsForValue().set(key, value, 1, TimeUnit.DAYS);
    }

    public void setStringAndLive(String key, String value, long liveTime) {
        stringRedisTemplate.opsForValue().set(key, value, liveTime, TimeUnit.SECONDS);
    }

    public void setStringAndLive(String key, String value, long liveTime, TimeUnit unit) {
        stringRedisTemplate.opsForValue().set(key, value, liveTime, unit);
    }


    /**
     * 设置订单 到redis，保持2天时间，之后就自动过期
     *
     * @param key
     * @param value
     */
    public void setOrderString(String key, String value) {
        stringRedisTemplate.opsForValue().set(key, value, orderLiveTime, TimeUnit.SECONDS);

    }

    /**
     * 获取过期时间
     *
     * @param key
     * @return
     */
    public long getKeyLiveTime(String key) {
        try {
            return stringRedisTemplate.opsForValue().getOperations().getExpire(key);
        } catch (Exception e) {
            return 0;
        }
    }

    public String getString(String key) {
        try {
            return stringRedisTemplate.opsForValue().get(key);
        } catch (Exception e) {
            return "";
        }
    }

    public Boolean deleteString(String key) {
        boolean flag = false;
        try {
            return stringRedisTemplate.delete(key);
        } catch (Exception e) {
            log.error("删除失败：{}", key);
        }
        return false;
    }

    /**
     * 获取模糊查询的key_value
     *
     * @param key
     * @return
     */
    public Map<String, String> getkeysMap(String key) {
        Set<String> set = new HashSet<>();
        if (key.contains("*")) {
            set = stringRedisTemplate.keys(key);
        }
        Map<String, String> map = new HashMap<>();
        for (String s : set) {
            map.put(s, stringRedisTemplate.opsForValue().get(s));
        }
        //List<String> values = stringRedisTemplate.opsForValue().multiGet(list);
        return map;
    }

    public Boolean isExistKey(String key) {
        return stringRedisTemplate.hasKey(key);
    }

    /**
     * 简单分布式锁 不带重入，不带续约；可用于重复提交
     *
     * @param key
     * @param timeout 时间
     * @param unit    单位
     * @return
     */
    public Boolean setIfAbsent(String key, final long timeout, final TimeUnit unit) {
        return setIfAbsent(key, "", timeout, unit);
    }
    //youwang 2022-05-24 v1.3.0 add

    /**
     * 简单分布式锁 不带重入，不带续约；可用于重复提交
     *
     * @param key
     * @param value
     * @param timeout 时间
     * @param unit    单位
     * @return
     */
    public Boolean setIfAbsent(String key, String value, final long timeout, final TimeUnit unit) {
        return stringRedisTemplate.opsForValue().setIfAbsent(key, value, timeout, unit);
    }

    public static void main(String[] args) {


    }

    public void delete(String key) {
        stringRedisTemplate.delete(key);
    }
}
