package com.tuigai.tuigai_tongcheng_api.service;



import com.tuigai.tuigai_tongcheng_api.mapper.RefoundPasengerMapper;
import com.tuigai.tuigai_tongcheng_api.model.RefoundPasenger;
import com.tuigai.tuigai_tongcheng_api.utils.DateUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * @ClassName RefoundPassengerServiceImpl
 * @Description TODO
 * @Author Tx
 * @Date 2023/5/24 15:52
 * @Version 1.0
 */
@Service
@Slf4j
public class RefoundPassengerServiceImpl {
    @Autowired
    public RefoundPasengerMapper refoundPasengerMapper;


    public int updateRefoundPasengerMapper(RefoundPasenger refoundPasengerTemp) {
        return refoundPasengerMapper.updateRefoundPasenger(refoundPasengerTemp);
    }


    public int addRefoundPasenger(List<RefoundPasenger> refoundPasengerList) {
        int i = 0;
        for (RefoundPasenger refoundPasenger : refoundPasengerList) {
            refoundPasengerMapper.addTrainPassenger(refoundPasenger);
            i++;
        }
        return i;
    }


    public int addRefoundPasengerBatch(List<RefoundPasenger> refoundPasengerList) {
        return refoundPasengerMapper.addList(refoundPasengerList);
    }

    /**
     * 批量gengxin
     *
     * @param refoundPasengers0
     */

    public void updateBath(List<RefoundPasenger> refoundPasengers0) {
        for (RefoundPasenger refoundPasenger : refoundPasengers0) {
            refoundPasengerMapper.updateOutId(refoundPasenger);
        }
    }


    public void removeById(Integer id) {
        refoundPasengerMapper.removeById(id);
    }


    public void updateCallBackByOutIdAndCardNumIn(String outId, List<String> cardNums, int isCallback, int isRetrun) {
        if (cardNums != null && cardNums.size() > 0) {
            refoundPasengerMapper.updateCallBackByOutIdAndCardNumIn(outId, cardNums, isCallback, isRetrun);
        }
    }


    public void updateCallBackByOutIdAndPassengerIdInWithIsCallbackNotNull(String outId, List<String> passengerIdList, int isCallback, int isRetrun) {
        if (passengerIdList != null && passengerIdList.size() > 0) {
            refoundPasengerMapper.updateCallBackByOutIdAndPassengerIdInWithIsCallbackNotNull(outId, passengerIdList, isCallback, isRetrun);
        }
    }


    public List<RefoundPasenger> getRefoundPasengerByOrderId(String orderId) {
        return refoundPasengerMapper.getRefoundPasengerByOrderId(orderId);
    }


    public int updateRefoundPasengerIsCallBack(RefoundPasenger refoundPasenger) {
        refoundPasenger.returnTime = DateUtil.format(new Date(), DateUtil.Format.YMD_HH_MM_SS);
        return refoundPasengerMapper.updateRefoundPasengerIsCallBack(refoundPasenger);
    }


    public List<RefoundPasenger> getRefoundPasengerByOutId(String outId) {
        return refoundPasengerMapper.getRefoundPasengerByOutId(outId);
    }
}
