package com.tuigai.tuigai_tongcheng_api.utils;

public class ConvertUtil {

    public enum SeatTypeConvertEnum {
        YZ("硬座", "1", "1"),

        YW("硬卧", "23", "3"),
        YWS("硬卧上", "2", "3T"),
        YWZ("硬卧中", "3", "3M"),
        YWX("硬卧下", "4", "3B"),
        RZ("软座", "5", "5"),

        RW("软卧", "24", "6"),
        RWS("软卧上", "6", "6T"),
        RWZ("软卧中", "7", "6M"),
        RWX("软卧下", "8", "6B"),
        SWZ("商务座", "9", "9"),
        DGNZ("多功能座", "10", "10"),
        EDBZ("二等包座", "11", "19"),
        TDZ("特等座", "12", "12"),
        YDZ("一等座", "13", "13"),
        EDZ("二等座", "14", "14"),
        GJRW("高级软卧", "42", "15"),
        GJRWS("高级软卧上", "15", "15T"),
        GJRWX("高级软卧下", "16", "15B"),
        WZ("无座", "17", "W"),
        YRRB("一人软包", "18", "30"),
        ERRB("二人软包", "19", "29"),


        YDRZ("一等软座", "25", "23"),
        EDRZ("二等软座", "26", "24"),
        TDRZ("特等软座", "27", "28"),
        BXYW("包厢硬卧", "22", "22"),
        BXYWS("包厢硬卧上", "28", "22T"),
        BXYWZ("包厢硬卧中", "29", "22M"),
        BXYWX("包厢硬卧下", "30", "22B"),
        BXRZ("包厢软座", "31", "27"),


        HBYZ("混编硬座", "34", "25"),
        HBRZ("混编软座", "35", "33"),

        YDW("一等卧", "32", "31"),
        YDWS("一等卧上", "36", "31T"),
        YDWZ("一等卧中", "37", "31M"),
        YDWX("一等卧下", "38", "31B"),

        EDW("二等卧", "33", "32"),
        EDWS("二等卧上", "39", "32T"),
        EDWZ("二等卧中", "40", "32M"),
        EDWX("二等卧下", "41", "32B"),
        DW("动卧", "20", "7"),
        DWS("动卧上", "43", "7T"),
        DWX("动卧下", "44", "7B"),

        GJDR("高级动卧", "21", "20"),
        GJDRS("高级动卧上", "45", "20T"),
        GJDRX("高级动卧下", "46", "20B"),

        HBYW("混编硬卧", "47", "26"),
        HBRW("混编软卧", "48", "34"),
        UNKNOW("未知", "99", "-1");


        //混编硬卧


        //混编软卧

        private String name;
        private String selfCode;
        private String otherCode;

        SeatTypeConvertEnum(String name, String selfCode, String otherCode) {
            this.selfCode = selfCode;
            this.otherCode = otherCode;
            this.name = name;
        }

        public String getSelfCode() {
            return selfCode;
        }

        public void setSelfCode(String selfCode) {
            this.selfCode = selfCode;
        }

        public String getOtherCode() {
            return otherCode;
        }

        public void setOtherCode(String otherCode) {
            this.otherCode = otherCode;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public static String getSelfCodeByOtherCode(String code) {
            for (SeatTypeConvertEnum value : values()) {
                if (value.otherCode.equals(code)) {
                    return value.selfCode;
                }
            }
            return "";
        }

        public static String getOtherCodeBySelfCode(String code) {
            for (SeatTypeConvertEnum value : values()) {
                if (value.selfCode.equals(code)) {
                    int length = value.otherCode.length();
                    int index = length;
                    for (int i = 0; i < length; i++) {
                        char c = value.otherCode.charAt(i);
                        if (!Character.isDigit(c)) {
                            index = i;
                            break;
                        }
                    }
                    return value.otherCode.substring(0, index);
                }
            }
            return "";
        }

        public static String getOtherNameBySelfCode(String code) {
            String otherCode = getOtherCodeBySelfCode(code);
            if (code.equals(SeatTypeConvertEnum.WZ.getSelfCode())) {
                return SeatTypeConvertEnum.WZ.name;
            }
            for (SeatTypeConvertEnum value : values()) {
                if (value.otherCode.equals(otherCode)) {
                    return value.name;
                }
            }
            return "";
        }

        public static String getSelfNameBySelfCode(String code) {
            for (SeatTypeConvertEnum value : values()) {
                if (value.selfCode.equals(code)) {
                    return value.name;
                }
            }
            return "";
        }

        public static String getSelfCodeByName(String name) {
            for (SeatTypeConvertEnum value : values()) {
                if (value.name.equals(name)) {
                    return value.selfCode;
                }
            }
            return "";
        }

    }

    public enum CertificateTypeConvertEnum {
        ID_CARD("1", "1", "身份证"),
        ID_CARD_GA("C", "4", "港澳居民来往内地通行证"),
        ID_CARD_TW("G", "3", "台湾居民来往大陆通行证"),
        PASSPORT("B", "2", "护照"),
        RESIDENCE_PERMIT_GA("I", "5", "港澳台居民居住证"),
        //RESIDENCE_PERMIT_GA1("I1", "17", "港澳居民居住证"),
        //RESIDENCE_PERMIT_GA2("I2", "18", "台湾居民居住证"),
        ID_CARD_OTHER("H", "6", "外国人永久居留身份证");


        private String selfCode;
        private String otherCode;
        private String name;

        CertificateTypeConvertEnum(String selfCode, String otherCode, String name) {
            this.selfCode = selfCode;
            this.otherCode = otherCode;
            this.name = name;
        }

        public String getSelfCode() {
            return selfCode;
        }

        public void setSelfCode(String selfCode) {
            this.selfCode = selfCode;
        }

        public String getOtherCode() {
            return otherCode;
        }

        public void setOtherCode(String otherCode) {
            this.otherCode = otherCode;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public static String getSelfCodeByOtherCode(String code) {
            for (CertificateTypeConvertEnum value : values()) {
                if (value.otherCode.equals(code)) {
                    return value.selfCode;
                }
            }
            return "";
        }

        public static String getOtherCodeBySelfCode(String code) {
            for (CertificateTypeConvertEnum value : values()) {
                if (value.selfCode.equals(code)) {
                    return value.otherCode;
                }
            }
            return "";
        }

        public static String getNameBySelfCode(String code) {
            for (CertificateTypeConvertEnum value : values()) {
                if (value.selfCode.equals(code)) {
                    return value.name;
                }
            }
            return "";
        }
    }


    public enum TicketTypeConvertEnum {
        ADULT_TICKET("成人票", "1", "1"),
        STUDENT_TICKET("学生票", "3", "3"),
        CHILD_TICKET("儿童票", "2", "2");
        private String selfCode;
        private String otherCode;
        private String name;

        TicketTypeConvertEnum(String name, String selfCode, String otherCode) {
            this.selfCode = selfCode;
            this.otherCode = otherCode;
            this.name = name;
        }

        public String getSelfCode() {
            return selfCode;
        }

        public void setSelfCode(String selfCode) {
            this.selfCode = selfCode;
        }

        public String getOtherCode() {
            return otherCode;
        }

        public void setOtherCode(String otherCode) {
            this.otherCode = otherCode;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public static String getSelfCodeByOtherCode(String code) {
            for (TicketTypeConvertEnum value : values()) {
                if (value.otherCode.equals(code)) {
                    return value.selfCode;
                }
            }
            return "";
        }

        public static String getOtherCodeBySelfCode(String code) {
            for (TicketTypeConvertEnum value : values()) {
                if (value.selfCode.equals(code)) {
                    return value.otherCode;
                }
            }
            return "";
        }

        public static String getNameBySelfCode(String code) {
            for (TicketTypeConvertEnum value : values()) {
                if (value.selfCode.equals(code)) {
                    return value.name;
                }
            }
            return "";
        }

    }

    public enum SexConvertEnum {
        MALE("男", "M", "0"),
        FEMALE("女", "F", "1");
        private String selfCode;
        private String otherCode;
        private String name;

        SexConvertEnum(String name, String selfCode, String otherCode) {
            this.selfCode = selfCode;
            this.otherCode = otherCode;
            this.name = name;
        }

        public String getSelfCode() {
            return selfCode;
        }

        public void setSelfCode(String selfCode) {
            this.selfCode = selfCode;
        }

        public String getOtherCode() {
            return otherCode;
        }

        public void setOtherCode(String otherCode) {
            this.otherCode = otherCode;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public static String getSelfCodeByOtherCode(String code) {
            for (SexConvertEnum value : values()) {
                if (value.otherCode.equals(code)) {
                    return value.selfCode;
                }
            }
            return "";
        }

        public static String getOtherCodeBySelfCode(String code) {
            for (SexConvertEnum value : values()) {
                if (value.selfCode.equals(code)) {
                    return value.otherCode;
                }
            }
            return "";
        }
    }

    public enum ForceMatchConvertEnum {
        MAST("必须", "0", "1"),
        PRECEDENCE("优先", "1", "0");
        private String selfCode;
        private String otherCode;
        private String name;

        ForceMatchConvertEnum(String name, String selfCode, String otherCode) {
            this.selfCode = selfCode;
            this.otherCode = otherCode;
            this.name = name;
        }

        public String getSelfCode() {
            return selfCode;
        }

        public void setSelfCode(String selfCode) {
            this.selfCode = selfCode;
        }

        public String getOtherCode() {
            return otherCode;
        }

        public void setOtherCode(String otherCode) {
            this.otherCode = otherCode;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public static String getSelfCodeByOtherCode(String code) {
            for (ForceMatchConvertEnum value : values()) {
                if (value.otherCode.equals(code)) {
                    return value.selfCode;
                }
            }
            return "";
        }

        public static String getOtherCodeBySelfCode(String code) {
            for (ForceMatchConvertEnum value : values()) {
                if (value.selfCode.equals(code)) {
                    return value.otherCode;
                }
            }
            return "";
        }
    }

    public enum YesOrNoConvertEnum {
        YES("是", "1", "0"),
        NO("否", "0", "1");
        private String selfCode;
        private String otherCode;
        private String name;

        YesOrNoConvertEnum(String name, String selfCode, String otherCode) {
            this.selfCode = selfCode;
            this.otherCode = otherCode;
            this.name = name;
        }

        public String getSelfCode() {
            return selfCode;
        }

        public void setSelfCode(String selfCode) {
            this.selfCode = selfCode;
        }

        public String getOtherCode() {
            return otherCode;
        }

        public void setOtherCode(String otherCode) {
            this.otherCode = otherCode;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public static String getSelfCodeByOtherCode(String code) {
            for (YesOrNoConvertEnum value : values()) {
                if (value.otherCode.equals(code)) {
                    return value.selfCode;
                }
            }
            return "";
        }

        public static String getOtherCodeBySelfCode(String code) {
            for (YesOrNoConvertEnum value : values()) {
                if (value.selfCode.equals(code)) {
                    return value.otherCode;
                }
            }
            return "";
        }
    }

}
